<template>
  <div>
    <div class="q-pa-md">

      <div class="row">
        <q-item
          class='col lang'
          :class='{ active: lang === locale }'
          v-for="lang in $i18n.availableLocales"
          :key="lang"
          clickable
          @click="locale = lang"
        >
          <q-item-section>
            {{ langFullName(lang) }}
          </q-item-section>
        </q-item>

      </div>
    </div>
  </div>
</template>

<script>
// import RotateArrow from '@/components/RotateArrow'

export default {
  components: {
    // RotateArrow
  },
  data () {
    return {
      menu: false
    }
  },
  computed: {
    locale: {
      get () {
        return this.$i18n.locale
      },
      set (val) {
        // setting quasar's language as well to get e.g. localized calendars
        // https://quasar.dev/options/quasar-language-packs#Change-Quasar-Language-Pack-at-Runtime
        // switching en with en-us since quasar doesn't have plain en
        const qLang = val === 'en' ? 'en-US' : val
        import(
          `quasar/lang/${qLang}`
        )
          .then((lang) => {
            this.$q.lang.set(lang.default)
          })
          .catch((err) =>
            console.error("Couldn't import quasar language:", err)
          )

        this.$i18n.locale = val
        localStorage.setItem('locale', val)
      }
    },
  },
  methods: {
    langFullName (locale) {
      return { en: 'ENGLISH', es: 'ESPAÑOL' }[locale]
    }
  },
  created () {
    // try to be smart when picking the default language

    const browserLang = navigator.languages.find((lang) =>
      this.$i18n.availableLocales.includes(lang)
    )

    // default to what the user had last time, if anything
    // otherwise get a language that the browser says the user prefers
    // if we don't have a language like that, fall back to english
    this.locale = localStorage.getItem('locale') || browserLang || 'en'
  }
}
</script>

<style scoped lang="scss">
.lang {
  text-transform: uppercase;
  font-weight: 800;
  font-size: var(--fs-1);
  letter-spacing: 1px;
  border-radius: var(--border-radius-2);
  border: solid 2px var(--color-white);
  cursor: pointer;
  user-select: none;
  padding-left: var(--spacing-2);
  padding-right: var(--spacing-0);
  display: flex;
  align-items: center;
}
.row:first-child {
  border-top-right-radius: 0;
  border-bottom-right-radius: 0;
}

.row:last-child {
  border-top-left-radius: 0;
  border-bottom-left-radius: 0;
}

.active {
  background-color: var(--color-white);
  color: var(--color-dark-text);
}
</style>
